<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'modelCode',
    label: '模型编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'ruleId',
    label: '规则编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'field',
    label: '字段',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'name',
    label: '名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'parameters',
    label: '默认值',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'format',
    label: '参数格式化',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'paramType',
    label: '参数类型',
    component: 'Select',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  modelCode: [required()],
  ruleId: [required()],
  field: [required()],
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

